<template>
  <section class="main-body-wrapper">
    <div class="container p-0">
      <div class="page-title w-100">
        <h1>Business Information</h1>
        <h2
          class="sub-title"
        >From its medieval origins to the digital era, learn everything there is to know</h2>
      </div>
      <div class="form-outer-wrap">
             <div class="form-wrapper form-company-info">
          <div class="container-fluid">
            <form class="row m-0">
              <div class="col-md-12">
                <div class="form-group">
                  <label for="businesslegalname" class>
                    <span>Business Legal name</span>
                    <i class="required-field float-left"></i>
                  </label>
                  <div class="input-wrapper">
                    <input
                      type="text"
                      v-model.lazy="$v.business.BusinessName.$model"
                      class="form-control"
                      :class="getValidationClass('BusinessName')"
                      id="business-legal-name"
                      placeholder="Business Legal name"
                      name="businesslegalname"
                    >
                    <span
                      class="success-icon"
                      v-if="$v.business.BusinessName.$dirty  && !$v.business.BusinessName.$invalid"
                    >
                      <i class="fa fa-check-circle" aria-hidden="true"></i>
                    </span>
                    <span class="error-icon" v-else-if="$v.business.BusinessName.$error">
                      <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                    </span>
                    <i
                      class="error-msg"
                      v-if="$v.business.BusinessName.$dirty && !$v.business.BusinessName.required"
                    >Please enter Business Legal name</i>

                  </div>
                </div>
              </div>
              <div class="col-md-12">
                <div class="form-group">
                  <label for="doingbusinessas" class>
                    <span>Doing Business as</span>
                  </label>
                  <div class="input-wrapper">
                    <input
                      type="text"
                      v-model.lazy="$v.business.DBA.$model"
                      id="doing-business-as"
                      :class="getValidationClass('DBA')"
                      class="form-control"
                      placeholder="Doing Business as"
                      name="doingbusinessas"
                    >
                    <span
                      class="success-icon"
                      v-if="$v.business.DBA.$dirty  && !$v.business.DBA.$invalid"
                    >
                      <i class="fa fa-check-circle" aria-hidden="true"></i>
                    </span>
                    <span class="error-icon" v-else-if="$v.business.DBA.$error">
                      <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                    </span>
                  </div>
                </div>
              </div>
              <div class="col-md-12">
                <div class="form-group">
                  <label for="ein" class>
                    <span>EIN</span>
                    <i class="required-field float-left"></i>
                  </label>
                  <div class="input-wrapper">
                    <input 
                      v-model.lazy="$v.business.EIN.$model"
                      v-mask="'##-#######'"
                      type="text"
                      class="form-control"
                      id="ein"
                      placeholder="EIN"
                      name="ein"
                      :class="getValidationClass('EIN')"
                   >
                    <span
                      class="success-icon"
                      v-if="$v.business.EIN.$dirty  && !$v.business.EIN.$invalid "
                    >
                      <i class="fa fa-check-circle" aria-hidden="true"></i>
                    </span>
                    <span class="error-icon" v-else-if="$v.business.EIN.$error">
                      <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                    </span>
                    <i
                      class="error-msg"
                  
                    v-if="$v.business.EIN.$dirty && !$v.business.EIN.required"
                    >Please enter  EIN </i>
                    <i
                      class="error-msg"
                    v-else-if="$v.business.EIN.$dirty && !$v.business.EIN.validein"
                    >Please enter 9 digts of EIN </i>
                  </div>
                </div>
              </div>
              <div class="col-md-12">
                <div class="form-group">
                  <label for="phonenumber" class>
                    <span>Phone</span>
                    <i class="required-field float-left"></i>
                  </label>
                  <div class="input-wrapper">
                    <input
                      :class="getValidationClass('Phone')"
                      v-model.lazy="$v.business.Phone.$model"
                      v-mask="'##########'"
                      type="text"
                      class="form-control"
                      id="phonenumber"
                      placeholder="Phone"
                      name="phonenumber"
                    >
                    <span
                      class="success-icon"
                      v-if="$v.business.Phone.$dirty  && !$v.business.Phone.$invalid"
                    >
                      <i class="fa fa-check-circle" aria-hidden="true"></i>
                    </span>
                    <span class="error-icon" v-else-if="$v.business.Phone.$error">
                      <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                    </span>
                    <i
                      class="error-msg"
                      v-if="$v.business.Phone.$dirty && !$v.business.Phone.required"
                    >Please enter Phone number</i>
										 <i class="error-msg" v-else-if="$v.business.Phone.$dirty && !$v.business.Phone.validphone">Please enter 10 digits of Phone number</i>
                  </div>
                </div>
              </div>
              <div class="col-lg-6 col-md-12">
                <div class="form-group">
                  <label for="StreetNum" class>
                    <span>Number</span>
                     <i class="required-field float-left"></i>
                  </label>
                  <div class="input-wrapper">
                    <input
                      v-model="$v.business.StreetNum.$model"
                      type="text"
                      class="form-control"
                      id="StreetNum"
                      placeholder="Number"
                      name="StreetNum"
                      :class="getValidationClass('StreetNum')"
                    >
                    <span
                      class="success-icon"
                      v-if="$v.business.StreetNum.$dirty  && !$v.business.StreetNum.$invalid"
                    >
                      <i class="fa fa-check-circle" aria-hidden="true"></i>
                    </span>
                    <span class="error-icon" v-else-if="$v.business.StreetNum.$error">
                      <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                    </span>
                    <i
                      class="error-msg"
                      v-if="$v.business.StreetNum.$dirty && !$v.business.StreetNum.required"
                    >Please enter Number</i>
                  </div>
                </div>
              </div>
              <div class="col-lg-6 col-md-12">
                <div class="form-group">
                  <label for="StreetName" class>
                    <span>Street</span>
                     <i class="required-field float-left"></i>
                  </label>
                  <div class="input-wrapper">
                    <input
                      v-model="$v.business.StreetName.$model"
                      type="text"
                      class="form-control"
                      id="StreetName"
                      placeholder="Street"
                      name="StreetName"
                      :class="getValidationClass('StreetName')"
                    >
                    <span
                      class="success-icon"
                      v-if="$v.business.StreetName.$dirty  && !$v.business.StreetName.$invalid"
                    >
                      <i class="fa fa-check-circle" aria-hidden="true"></i>
                    </span>
                    <span class="error-icon" v-else-if="$v.business.StreetName.$error">
                      <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                    </span>
                    <i
                      class="error-msg"
                      v-if="$v.business.StreetName.$dirty && !$v.business.StreetName.required"
                    >Please enter Street</i>

                  </div>
                </div>
              </div>

              <div class="col-lg-6 col-md-12">
                <div class="form-group">
                  <label for="City" class>
                    <span>City</span>
                     <i class="required-field float-left"></i>
                  </label>
                  <div class="input-wrapper">
                    <input
                      type="text"
                      class="form-control"
                      v-model="$v.business.City.$model"
                      placeholder="City"
                      name="city"
                      :class="getValidationClass('City')"

                    >
                    <span
                      class="success-icon"
                      v-if="$v.business.City.$dirty  && !$v.business.City.$invalid"
                    >
                      <i class="fa fa-check-circle" aria-hidden="true"></i>
                    </span>
                    <span class="error-icon" v-else-if="$v.business.City.$error">
                      <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                    </span>
                    <i
                      class="error-msg"
                      v-if="$v.business.City.$dirty && !$v.business.City.required"
                    >Please enter City</i>

                  </div>
                </div>
              </div>
              <div class="col-lg-6 col-md-12">
                <div class="form-group">
                  <label for="State" class>
                    <span>State</span>
                    <i class="required-field float-left"></i>
                  </label>
                  <div class="input-wrapper">
                     <select
                      class="form-control"
                      name="state"
                      :class="getValidationClass('StateProv')"
                      v-model.lazy="$v.business.StateProv.$model"
                    >
                      <option value="">Select State</option>
                      <option v-for="(option,id) in states" :key="id">{{option}}</option>
                    </select>

                    <span
                      class="success-icon"
                      v-if="$v.business.StateProv.$dirty  && !$v.business.StateProv.$invalid"
                    >
                      <i class="fa fa-check-circle" aria-hidden="true"></i>
                    </span>
                    <span class="error-icon" v-else-if="$v.business.StateProv.$error">
                      <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                    </span>
                    <i
                      class="error-msg"
                      v-if="$v.business.StateProv.$dirty && !$v.business.StateProv.required"
                    >Please select State</i>

                  </div>
                </div>
              </div>
              <div class="col-lg-6 col-md-12">
                <div class="form-group">
                  <label for="Zip code" class>
                    <span>Zip code</span>
                     <i class="required-field float-left"></i>
                  </label>
                  <div class="input-wrapper">
                    <input
                      type="text"
                      v-model="$v.business.PostalCode.$model"
                      v-mask="'#####'"
                      class="form-control"
                      placeholder="Zip code"
                      name="Postalcode"
                      :class="getValidationClass('PostalCode')"

                    >
                    <span
                      class="success-icon"
                      v-if="$v.business.PostalCode.$dirty  && !$v.business.PostalCode.$invalid"
                    >
                      <i class="fa fa-check-circle" aria-hidden="true"></i>
                    </span>
                    <span class="error-icon" v-else-if="$v.business.PostalCode.$error">
                      <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                    </span>
                    <i
                      class="error-msg"
                      v-if="$v.business.PostalCode.$dirty && !$v.business.PostalCode.required"
                    >Please enter Zip code</i>
                     <i
                      class="error-msg"
                      v-if="$v.business.PostalCode.$dirty && !$v.business.PostalCode.validzipcode"
                    >Please enter 5 digits of Zip code</i>


                  </div>
                </div>
              </div>
                   <div class="col-lg-6 col-md-12">
                <div class="form-group">
                  <label for="country" class>
                    <span>Country</span>
                    <i class="required-field float-left"></i>
                  </label>
                  <div class="input-wrapper">
                    <select class="form-control" name="country" id="mySelect" value="USA" disabled>
                      <option>USA</option>
                    </select>
                  </div>
                </div>
              </div>
              <div class="col-md-12">
                <div class="form-group">
                  <label for="websitelink" class>
                    <span>Website Link</span>
                    <i class="required-field float-left"></i>
                  </label>
                  <div class="input-group input-wrapper">
                    <div class="input-group-append">
                      <span class="input-group-text">https://</span>
                    </div>
                    <input
                      v-model="$v.business.Website.$model"
                      type="text"
                      class="form-control web-link"
                      id="phonenumber"
                      placeholder
                      name="websitelink"
                      :class="getValidationClass('Website')"
                    >
                    <span
                      class="success-icon"
                      v-if="$v.business.Website.$dirty  && !$v.business.Website.$invalid"
                    >
                      <i class="fa fa-check-circle" aria-hidden="true"></i>
                    </span>
                    <span class="error-icon" v-else-if="$v.business.Website.$error">
                      <i class="fa fa-exclamation-triangle" aria-hidden="true"></i>
                    </span>
                  </div>
                  <i class="error-msg" v-if="$v.business.Website.$dirty && !$v.business.Website.required">
                    Please enter Website Link</i>
                  <i
                      class="error-msg"
                     v-if="$v.business.Website.$dirty && !$v.business.Website.website"
                    >Enter correct Website url</i>
                </div>
              </div>
            </form>
          </div>
        </div>
       
        <div class="form-wrapper form-company-info pb-5 hello">
          <div class="container-fluid">
            <div class="row m-0" v-for="(person,index) in identity.people" :key="index" id="add-owner-loop">
              <div class="col-md-12">
                <div id="form-border-wrap">
                	<hr id="form-border" />
                </div>
              </div>
              <div class="col-md-12">
								<div class="owner-detail">
									<h3>Business Owner Detail</h3>
									<div class="remove-icon" @click.prevent="removeIndividual(index)">
										<a href="">
											 <i class="fa fa-trash" aria-hidden="true"></i>
										</a>
									</div>
								</div>
							</div>
               <IndividualSubForm :individual="person" :type="'business'" :v="$v.people.$each.$iter[index]"/> 
            </div>
           <div class="row mx-0">
                <div class="col-md-12">
                  <div class="add-owner-wrap">
                    <a href class="add-owner" v-on:click.prevent="addAnother">
                      <span><i class="fas fa-plus"></i>Add Owner</span>
                    </a>
                  </div>
                  <div class="alert alert-danger alert-msg mb-md-3" v-if="totalOwnership<76">
                    <i aria-hidden="true" class="fa fa-exclamation-triangle mr-2"></i>Total ownership percentage should sum up to at least 76%.
                  </div>
                </div>
            </div>
            <div class="row m-0">
              <div class="col-lg-6 col-md-12">
                <div class="previous-step-wrap">
                  <a v-on:click.prevent="back" class="previous-step">Previous Step</a>
                </div>
              </div>
              <div class="col-lg-6 col-md-12">
                <div class="continue-btn-wrap">
                  <button  v-on:click.prevent="next" type="submit" class="btn continue-btn">Continue</button>
                </div>
              </div>
            </div>
            <h1>{{dell}}</h1>
          </div>
        </div>
      </div>
    </div>
  </section>
</template>

<script>
import { required, minLength, between, email } from "vuelidate/lib/validators";
import IndividualSubForm from "../components/IndividualSubForm";
import { helpers } from 'vuelidate/lib/validators'

const validein  = helpers.regex('validein', /^\d{2}\-?\d{7}$/)
const validDate = (date) => {
      var nowdate = new Date();
      var diff = nowdate.getFullYear() - date.split('-')[0];
      if(diff > 18){ return true } else { return false }
}

const website = (userInput) => {
       var res = userInput.match(/[-a-zA-Z0-9@:%._\+~#=]{2,256}\.[a-z]{2,6}\b([-a-zA-Z0-9@:%_\+.~#?&//=]*)/g);
      if(res == null) {return false} else {return true};
}

const validphone  = helpers.regex('validphone', /^\d{10}$/)
const validzipcode = helpers.regex('validzipcode',/^\d{5}$/)
 

export default {
  name: 'CompanyForm',
  components: {
	   IndividualSubForm
  },
  data () {
    return {
      token: localStorage.getItem('token'),
      states: [ "AL", "AK", "AZ", "AR", "CA", "CO", "CT", "DE", "FL", "GA", "HI", "ID", "IL", "IA", "KS", "KY", "LA", "ME", "MD", "MN", "MS", "MD", "MO", "MT", "NE", "NV", "NH", "NT", "ND", " NJ", "NM", "NY", "NC", "ND", "OH", "Ok", "OR", "PA", "RI", "SC", "SD", "TN", "TX", "UT", "VA", "VT", "WA", "WV", "WI", "WY" ],
      loading: true,
      identity: {},
      people: [],
      error: false,
      totalOwnership: 0,
      ownerShipError: false,
      fullurl:'5556',
    }
  },
  watch: {
    "identity.people": {
       handler: function (val, oldVal) {
              var totalOwnership = 0;
              this.identity.people.map((people,key)=>{
                  if(people.OwnershipPerc){
                      totalOwnership = totalOwnership+people.OwnershipPerc;
                  }
              })
              this.totalOwnership = totalOwnership;
      },
      deep: true
    },
    dell:function(val){
      this.$v.business.Website.$model=this.dell
  },
  },

      computed:{
    dell:function(val){
      return 'http://'+this.business.Website
    }
      },


    validations: {
    
   business: {
      BusinessName: {
        required,
      },
      DBA: {
       
      },
      EIN: {
        required,
        validein
      },
      Phone: {
        required,
        validphone
      },
      StreetNum: {
        required,
      },
      StreetName:{
        required,
      },
      City:{
        required,
      },
      StateProv:{
        required,
      },
      PostalCode:{
        required,
        validzipcode
      },
      Website:{
        required,
        website
      },
    },
    people: {
      required,
      minLength: minLength(1),
        $each: {
          FirstName: {
          required
        },
        LastName: {
          required
        },

        MiddleName: {
          
        },
        OwnershipPerc: {
            between: between(1, 100)
        },
        BirthDt: {
          required,
          validDate
        },
        Phone: {
          required,
          validphone
        },
        StreetNum: {
          required
        },
        StreetName: {
          required
        },
        City: {
          required
        },
        PostalCode: {
          required,
          validzipcode
        },
        StateProv: {
          required
        },
        TaxId: {
          required
        }
      }
    }

  },
  async mounted () {
    let that = this  
    localStorage.setItem('type', 'CompanyForm' )
    let identity= await this.$axios({
      "url": "/onboarding/accounts/identity",
      "method": "GET",
      "headers": { 
        "content-type": "application/json",
        "authorization": "Bearer " + this.token 
      }
    })
    .then(response => {
       var identity =  response.data.identity;
        identity.people.map((person,key)=> {
             if(!person.OwnershipPerc){
                 identity.people[key].OwnershipPerc = 0;
             }
        })
        that.identity = response.data.identity;
        that.business = that.identity.business;
        that.people = that.identity.people;
        that.loading = false;
      })
    .catch(error => {
       let logObject = {module: "onboarding",error: error, details: {page: "companyForm.asyncMounted",endpoint: "/onboarding/accounts/identity"}};
       this.$store.commit('logError', logObject);
    })
    // setTimeout(() => { 
    //       this.$refs.businesslegalname.focus();
    // }, 10);
  },
  methods: {
    back: function() {
      this.$router.push({"name": "MerchantType"})
    },
    getValidationClass(fieldName) {
      const field = this.$v.business[fieldName];
      if (field) {
        return field.$dirty && field.$invalid
          ? "error-brdr"
          : field.$dirty && !field.$invalid
          ? "success-brdr"
          : "";
      }
    },
    addAnother: function() {
      let index= this.identity.people.length
      var indentity = {
            FirstName:'',
            MiddleName:'',
            LastName:'',
            BirthDt:'',
            PhoneType:'',
            Phone:'',
            OwnershipPerc: 0,
            StreetNum:'',
            StreetName:'',
            City:'',
            StateProv:'',
            PostalCode:'',
            TINType:'',
            TaxId:''
      };
      if(this.$NODE_ENV=='development'){
       indentity = {
            FirstName:'Another',
            MiddleName:'Lynn',
            LastName:'Varnell',
            BirthDt:'1974-06-25',
            PhoneType:'2',
            Phone:'2149244554',
            OwnershipPerc: 0,
            StreetNum:'1004',
            StreetName:'Bluebonnet Ct',
            City:'McKinney',
            StateProv:'TX',
            PostalCode:'75070',
            TINType:'1',
            TaxId:'457711389'
          };
      }
      this.$set(this.identity.people,index, indentity)
      
        console.log(this.identity.people);
    },
    removeIndividual:function(event){
           this.$delete(this.identity.people, event);             
    },
    next: function() {
      let that = this;
      this.$v.$touch();
     if(this.$v.$anyError || this.totalOwnership < 76 ){    
        this.$toasted.show('There are form errors, please check',{
            type : 'error',
            duration : 3000,
            position: "top-right", 
        })        
        return false;
      }
      that.identity.business = that.business;
      let data={
          "identity": this.identity
      }
      this.$axios({
        "url": "/onboarding/accounts",
        "method": "PUT",
        "headers": { 
          "content-type": "application/json",
          "authorization": "Bearer " + this.token 
        },
        "data": data
      })
       .then(response => {
        this.$store.commit('setStepProgress', {step: 2,status:  'completed'})
        that.$router.push({"name": "ConnectToBank"})
      })
      .catch(error => {
        this.submitted=false
        let logObject = {module: "onboarding",error: error, details: {page: "companyForm.next",endpoint:"/onboarding/accounts",data: data}};
        this.$store.commit('logError', logObject);
      })
    }
  }

}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
</style>

